<script setup lang="ts">
    import { ListableItem } from '../entities/ListableItem'
    import { isDefined } from '@/shared/helpers/types'

    interface Props {
        item: ListableItem
        isPinned?: boolean
        pinable?: boolean
        noImage?: boolean
        itemHeight?: number
    }

    defineEmits<{
        (e: 'pin'): void
        (e: 'unpin'): void
    }>()

    const props = withDefaults(defineProps<Props>(), {
        noImage: false,
        pinable: false,
        pinned: false,
        itemHeight: undefined,
    })

    const secondaryAction = props.item.getItemSecondaryAction?.()
</script>

<template>
    <v-list-item
        :data-cy="`listItem-Component-${item.getItemId()}`"
        class="pa-3"
        :style="{ height: `${itemHeight}px` }"
        @click="item.primaryAction?.()"
    >
        <v-icon
            v-if="item.isRequiringAttention()"
            class="position-absolute"
            style="
                top: 50%;
                right: 5px;
                transform: translateY(-50%);
                opacity: 0.6;
            "
            :style="{ fontSize: `${(itemHeight ?? 100) * 0.8}px` }"
            icon="mdi-message-alert-outline"
            color="warning"
        />

        <template #prepend>
            <slot name="prepend">
                <template v-if="!noImage">
                    <v-avatar
                        rounded
                        size="67"
                        class="float-left"
                        data-cy="illustration"
                    >
                        <v-icon
                            v-if="!item.getItemImageUrl()"
                            class="text-h3"
                            color="grey-lighten-2"
                            data-cy="no-image-icon"
                        >
                            mdi-camera-off-outline
                        </v-icon>
                        <v-img
                            v-else
                            :src="item.getItemThumbnailUrl()?.href"
                            :alt="item.getItemTitle()"
                            cover
                            aspect-ratio="1"
                        >
                        </v-img>
                    </v-avatar>
                </template>
            </slot>
        </template>

        <div class="d-flex justify-space-between">
            <v-list-item-title
                class="item-title text-subtitle-1"
                data-cy="title"
            >
                {{ item.getItemTitle() }}
            </v-list-item-title>
            <div class="d-flex">
                <v-chip
                    v-for="itemChip in item.getItemChips()"
                    :key="itemChip.label"
                    data-cy="component-chip"
                    size="small"
                    variant="flat"
                    :color="itemChip.color"
                    class="text-capitalize"
                >
                    {{ itemChip.label }}
                </v-chip>
                <slot name="append-chip"></slot>
            </div>
        </div>
        <v-list-item-subtitle
            v-if="typeof item.getItemDescription() === 'string'"
            class="text-subtitle-2"
            data-cy="subtitle"
        >
            {{ item.getItemDescription() }}
        </v-list-item-subtitle>
        <div v-if="Array.isArray(item.getItemDescription())">
            <v-list-item-subtitle
                v-for="descriptionRaw in item.getItemDescription()"
                :key="descriptionRaw"
                class="text-subtitle-2"
                data-cy="subtitle"
            >
                {{ descriptionRaw }}
            </v-list-item-subtitle>
        </div>
        <v-list-item-subtitle class="text-right" data-cy="anteriority">
            {{ item.getItemTemporalData() }}
        </v-list-item-subtitle>
        <slot name="extension"></slot>
        <template #append>
            <div v-if="pinable">
                <v-btn
                    v-if="isPinned"
                    variant="text"
                    icon="mdi-pin"
                    color="grey"
                    data-cy="is-pinned"
                    @click.stop="$emit('unpin')"
                ></v-btn>
                <v-btn
                    v-else
                    variant="text"
                    icon="mdi-pin-outline"
                    color="grey"
                    data-cy="is-not-bookmarked"
                    @click.stop="$emit('pin')"
                ></v-btn>
            </div>
            <v-btn
                v-if="isDefined(secondaryAction)"
                variant="tonal"
                :icon="secondaryAction.icon"
                color="secondary"
                data-cy="secondary-action"
                @click.prevent="secondaryAction.action"
            ></v-btn>
        </template>
    </v-list-item>
</template>
